#!/bin/sh

PACKAGEMANAGER="不明"
PACKAGECOUNT="0"
unamestr=$(uname)

if wc -v >/dev/null 2>&1; then
  wc_count() {
    wc -ln
  }
else
  wc_count() {
    wc -l | tr -d '[:space:]'
  }
fi

if [ "$unamestr" = 'Linux' ]; then
  platform=$(cat /etc/os-release | grep "^ID=" | sed -e "s/ID=//")
  if [ "$platform" = 'alpine' ] || [ "$platform" = 'postmarketos' ]; then
    PACKAGEMANAGER="apk"
    PACKAGECOUNT=$(apk info -I | wc_count)
  elif [ "$platform" = 'arch' ] || [ "$platform" = 'artix' ]; then
    PACKAGEMANAGER="pacman"
    PACKAGECOUNT=$(pacman -Qq | wc_count)
  elif [ "$platform" = 'crux' ]; then
    PACKAGEMANAGER="pkginfo"
    PACKAGECOUNT=$(pkginfo -i | wc_count)
  elif [ "$platform" = 'debian' ] || [ "$platform" = 'devuan' ]; then
    PACKAGEMANAGER="dpkg-query"
    PACKAGECOUNT=$(dpkg-query -f '.\n' -W | wc_count)
  elif [ "$platform" = 'gentoo' ]; then
    PACKAGEMANAGER="qlist"
    PACKAGECOUNT=$(qlist -IC | wc_count)
  elif [ "$platform" = 'void' ]; then
    PACKAGEMANAGER="xbps-query"
    PACKAGECOUNT=$(xbps-query -l | wc_count)
  fi
elif [ "$unamestr" = 'FreeBSD' ]; then
  PACKAGEMANAGER="pkg"
  PACKAGECOUNT=$(pkg info -a | wc_count)
elif [ "$unamestr" = 'OpenBSD' ]; then
  PACKAGEMANAGER="pkg_info"
  PACKAGECOUNT=$(pkg_info | wc_count)
elif [ "$unamestr" = 'NetBSD' ]; then
  PACKAGEMANAGER="pkg_info"
  PACKAGECOUNT=$(pkg_info -a | wc_count)
elif [ "$unamestr" = 'SunOS' ]; then
  PACKAGEMANAGER="pkg"
  PACKAGECOUNT=$(pkg list | wc_count)
fi

echo "PACKAGES='\"$PACKAGECOUNT ($PACKAGEMANAGER)\"'"
